/* c/zx-aux.c - WARNING: This file was auto generated by xsd2sg.pl. DO NOT EDIT!
 * $Id$ */
/* Code generation design Copyright (c) 2006 Sampo Kellomaki (sampo@iki.fi),
 * All Rights Reserved. NO WARRANTY. See file COPYING for terms and conditions
 * of use. Some aspects of code generation were driven by schema
 * descriptions that were used as input and may be subject to their own copyright.
 * Code generation uses a template, whose copyright statement follows. */

/** aux-templ.c  -  Auxiliary functions template: cloning, freeing, walking data
 ** Copyright (c) 2006 Symlabs (symlabs@symlabs.com), All Rights Reserved.
 ** Author: Sampo Kellomaki (sampo@iki.fi)
 ** This is confidential unpublished proprietary source code of the author.
 ** NO WARRANTY, not even implied warranties. Contains trade secrets.
 ** Distribution prohibited unless authorized in writing.
 ** Licensed under Apache License 2.0, see file COPYING.
 ** Id: aux-templ.c,v 1.12 2008-10-04 23:42:14 sampo Exp $
 **
 ** 30.5.2006, created, Sampo Kellomaki (sampo@iki.fi)
 ** 6.8.2006, factored from enc-templ.c to separate file --Sampo
 **
 ** N.B: wo=wire order (needed for exc-c14n), so=schema order
 **/

#include <memory.h>
#include "errmac.h"
#include "zx.h"
#include "c/zx-const.h"
#include "c/zx-data.h"



#ifdef EL_NAME
#undef EL_NAME
#endif
#ifdef EL_STRUCT
#undef EL_STRUCT
#endif
#ifdef EL_NS
#undef EL_NS
#endif
#ifdef EL_TAG
#undef EL_TAG
#endif

#define EL_NAME   root
#define EL_STRUCT zx_root_s
#define EL_NS     
#define EL_TAG    root

/* FUNC(zx_NEW_root) */

/* Trivial allocator/constructor for the datatype. */

/* Called by: */
struct zx_root_s* zx_NEW_root(struct zx_ctx* c, struct zx_elem_s* father)
{
  struct zx_root_s* x = ZX_ZALLOC(c, struct zx_root_s);
  x->gg.g.tok = zx_root_ELEM;
  if (father) {
    x->gg.g.n = &father->kids->g;
    father->kids = &x->gg;
  }
  return x;
}

#ifdef ZX_ENA_AUX

/* FUNC(zx_DUP_STRS_root) */

/* Depth first traversal of data structure to copy its simple strings
 * to memory allocated from the memory allocator. The decoder will
 * use the underlying wireprotocol PDU buffer for strings, i.e.
 * strings are not copied - they point to the real data. If the
 * datastructure needs to outlast the protocol data or needs a different
 * memory allocation strategy, you need to call this function.  */

/* Called by: */
void zx_DUP_STRS_root(struct zx_ctx* c, struct zx_root_s* x)
{
  struct zx_elem_s* se  MAYBE_UNUSED;
  zx_dup_strs_common(c, &x->gg);
  /* *** deal with xmlns specifications in exc c14n way */


  for (se = &x->Assertion->gg;
       se && se->g.tok == zx_sa_Assertion_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sa_Assertion(c, (struct zx_sa_Assertion_s*)se);
  for (se = &x->EncryptedAssertion->gg;
       se && se->g.tok == zx_sa_EncryptedAssertion_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sa_EncryptedAssertion(c, (struct zx_sa_EncryptedAssertion_s*)se);
  for (se = &x->NameID->gg;
       se && se->g.tok == zx_sa_NameID_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sa_NameID(c, (struct zx_sa_NameID_s*)se);
  for (se = &x->EncryptedID->gg;
       se && se->g.tok == zx_sa_EncryptedID_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sa_EncryptedID(c, (struct zx_sa_EncryptedID_s*)se);
  zx_dup_strs_simple_elems(c, x->NewID);
  for (se = &x->AuthnRequest->gg;
       se && se->g.tok == zx_sp_AuthnRequest_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sp_AuthnRequest(c, (struct zx_sp_AuthnRequest_s*)se);
  for (se = &x->Response->gg;
       se && se->g.tok == zx_sp_Response_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sp_Response(c, (struct zx_sp_Response_s*)se);
  for (se = &x->LogoutRequest->gg;
       se && se->g.tok == zx_sp_LogoutRequest_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sp_LogoutRequest(c, (struct zx_sp_LogoutRequest_s*)se);
  for (se = &x->LogoutResponse->gg;
       se && se->g.tok == zx_sp_LogoutResponse_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sp_LogoutResponse(c, (struct zx_sp_LogoutResponse_s*)se);
  for (se = &x->ManageNameIDRequest->gg;
       se && se->g.tok == zx_sp_ManageNameIDRequest_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sp_ManageNameIDRequest(c, (struct zx_sp_ManageNameIDRequest_s*)se);
  for (se = &x->ManageNameIDResponse->gg;
       se && se->g.tok == zx_sp_ManageNameIDResponse_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sp_ManageNameIDResponse(c, (struct zx_sp_ManageNameIDResponse_s*)se);
  for (se = &x->Envelope->gg;
       se && se->g.tok == zx_e_Envelope_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_e_Envelope(c, (struct zx_e_Envelope_s*)se);
  for (se = &x->Header->gg;
       se && se->g.tok == zx_e_Header_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_e_Header(c, (struct zx_e_Header_s*)se);
  for (se = &x->Body->gg;
       se && se->g.tok == zx_e_Body_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_e_Body(c, (struct zx_e_Body_s*)se);
  for (se = &x->EntityDescriptor->gg;
       se && se->g.tok == zx_md_EntityDescriptor_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_md_EntityDescriptor(c, (struct zx_md_EntityDescriptor_s*)se);
  for (se = &x->EntitiesDescriptor->gg;
       se && se->g.tok == zx_md_EntitiesDescriptor_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_md_EntitiesDescriptor(c, (struct zx_md_EntitiesDescriptor_s*)se);
  for (se = &x->XACMLAuthzDecisionQuery->gg;
       se && se->g.tok == zx_xasp_XACMLAuthzDecisionQuery_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_xasp_XACMLAuthzDecisionQuery(c, (struct zx_xasp_XACMLAuthzDecisionQuery_s*)se);
  for (se = &x->XACMLPolicyQuery->gg;
       se && se->g.tok == zx_xasp_XACMLPolicyQuery_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_xasp_XACMLPolicyQuery(c, (struct zx_xasp_XACMLPolicyQuery_s*)se);
  for (se = &x->xaspcd1_XACMLAuthzDecisionQuery->gg;
       se && se->g.tok == zx_xaspcd1_XACMLAuthzDecisionQuery_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_xaspcd1_XACMLAuthzDecisionQuery(c, (struct zx_xaspcd1_XACMLAuthzDecisionQuery_s*)se);
  for (se = &x->xaspcd1_XACMLPolicyQuery->gg;
       se && se->g.tok == zx_xaspcd1_XACMLPolicyQuery_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_xaspcd1_XACMLPolicyQuery(c, (struct zx_xaspcd1_XACMLPolicyQuery_s*)se);
  for (se = &x->EndpointReference->gg;
       se && se->g.tok == zx_a_EndpointReference_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_a_EndpointReference(c, (struct zx_a_EndpointReference_s*)se);
  for (se = &x->Token->gg;
       se && se->g.tok == zx_sec_Token_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sec_Token(c, (struct zx_sec_Token_s*)se);
  for (se = &x->Candidate->gg;
       se && se->g.tok == zx_hrxml_Candidate_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_hrxml_Candidate(c, (struct zx_hrxml_Candidate_s*)se);
  for (se = &x->sa11_Assertion->gg;
       se && se->g.tok == zx_sa11_Assertion_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sa11_Assertion(c, (struct zx_sa11_Assertion_s*)se);
  for (se = &x->Request->gg;
       se && se->g.tok == zx_sp11_Request_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sp11_Request(c, (struct zx_sp11_Request_s*)se);
  for (se = &x->sp11_Response->gg;
       se && se->g.tok == zx_sp11_Response_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_sp11_Response(c, (struct zx_sp11_Response_s*)se);
  for (se = &x->ff12_Assertion->gg;
       se && se->g.tok == zx_ff12_Assertion_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_ff12_Assertion(c, (struct zx_ff12_Assertion_s*)se);
  for (se = &x->ff12_AuthnRequest->gg;
       se && se->g.tok == zx_ff12_AuthnRequest_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_ff12_AuthnRequest(c, (struct zx_ff12_AuthnRequest_s*)se);
  for (se = &x->AuthnResponse->gg;
       se && se->g.tok == zx_ff12_AuthnResponse_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_ff12_AuthnResponse(c, (struct zx_ff12_AuthnResponse_s*)se);
  for (se = &x->AuthnRequestEnvelope->gg;
       se && se->g.tok == zx_ff12_AuthnRequestEnvelope_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_ff12_AuthnRequestEnvelope(c, (struct zx_ff12_AuthnRequestEnvelope_s*)se);
  for (se = &x->AuthnResponseEnvelope->gg;
       se && se->g.tok == zx_ff12_AuthnResponseEnvelope_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_ff12_AuthnResponseEnvelope(c, (struct zx_ff12_AuthnResponseEnvelope_s*)se);
  for (se = &x->RegisterNameIdentifierRequest->gg;
       se && se->g.tok == zx_ff12_RegisterNameIdentifierRequest_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_ff12_RegisterNameIdentifierRequest(c, (struct zx_ff12_RegisterNameIdentifierRequest_s*)se);
  for (se = &x->RegisterNameIdentifierResponse->gg;
       se && se->g.tok == zx_ff12_RegisterNameIdentifierResponse_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_ff12_RegisterNameIdentifierResponse(c, (struct zx_ff12_RegisterNameIdentifierResponse_s*)se);
  for (se = &x->FederationTerminationNotification->gg;
       se && se->g.tok == zx_ff12_FederationTerminationNotification_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_ff12_FederationTerminationNotification(c, (struct zx_ff12_FederationTerminationNotification_s*)se);
  for (se = &x->ff12_LogoutRequest->gg;
       se && se->g.tok == zx_ff12_LogoutRequest_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_ff12_LogoutRequest(c, (struct zx_ff12_LogoutRequest_s*)se);
  for (se = &x->ff12_LogoutResponse->gg;
       se && se->g.tok == zx_ff12_LogoutResponse_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_ff12_LogoutResponse(c, (struct zx_ff12_LogoutResponse_s*)se);
  for (se = &x->NameIdentifierMappingRequest->gg;
       se && se->g.tok == zx_ff12_NameIdentifierMappingRequest_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_ff12_NameIdentifierMappingRequest(c, (struct zx_ff12_NameIdentifierMappingRequest_s*)se);
  for (se = &x->NameIdentifierMappingResponse->gg;
       se && se->g.tok == zx_ff12_NameIdentifierMappingResponse_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_ff12_NameIdentifierMappingResponse(c, (struct zx_ff12_NameIdentifierMappingResponse_s*)se);
  for (se = &x->m20_EntityDescriptor->gg;
       se && se->g.tok == zx_m20_EntityDescriptor_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_m20_EntityDescriptor(c, (struct zx_m20_EntityDescriptor_s*)se);
  for (se = &x->m20_EntitiesDescriptor->gg;
       se && se->g.tok == zx_m20_EntitiesDescriptor_ELEM;
       se = (struct zx_elem_s*)se->g.n)
    zx_DUP_STRS_m20_EntitiesDescriptor(c, (struct zx_m20_EntitiesDescriptor_s*)se);

}

/* FUNC(zx_DEEP_CLONE_root) */

/* Depth first traversal of data structure to clone it and its sublements.
 * The simple strings are handled as a special case according to dup_strs flag. */

/* Called by: */
struct zx_root_s* zx_DEEP_CLONE_root(struct zx_ctx* c, struct zx_root_s* x, int dup_strs)
{
  struct zx_elem_s* e   MAYBE_UNUSED;
  struct zx_elem_s* en  MAYBE_UNUSED;
  struct zx_elem_s* enn MAYBE_UNUSED;

  x = (struct zx_root_s*)zx_clone_elem_common(c, &x->gg, sizeof(struct zx_root_s), dup_strs);
  /* *** deal with xmlns specifications in exc c14n way */


  for (enn = 0, e = &x->Assertion->gg;
       e && e->g.tok == zx_sa_Assertion_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sa_Assertion(c,(struct zx_sa_Assertion_s*)e,dup_strs);
  	  if (!enn)
  	      x->Assertion = (struct zx_sa_Assertion_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->EncryptedAssertion->gg;
       e && e->g.tok == zx_sa_EncryptedAssertion_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sa_EncryptedAssertion(c,(struct zx_sa_EncryptedAssertion_s*)e,dup_strs);
  	  if (!enn)
  	      x->EncryptedAssertion = (struct zx_sa_EncryptedAssertion_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->NameID->gg;
       e && e->g.tok == zx_sa_NameID_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sa_NameID(c,(struct zx_sa_NameID_s*)e,dup_strs);
  	  if (!enn)
  	      x->NameID = (struct zx_sa_NameID_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->EncryptedID->gg;
       e && e->g.tok == zx_sa_EncryptedID_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sa_EncryptedID(c,(struct zx_sa_EncryptedID_s*)e,dup_strs);
  	  if (!enn)
  	      x->EncryptedID = (struct zx_sa_EncryptedID_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  x->NewID = zx_deep_clone_simple_elems(c,x->NewID, dup_strs);
  for (enn = 0, e = &x->AuthnRequest->gg;
       e && e->g.tok == zx_sp_AuthnRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sp_AuthnRequest(c,(struct zx_sp_AuthnRequest_s*)e,dup_strs);
  	  if (!enn)
  	      x->AuthnRequest = (struct zx_sp_AuthnRequest_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->Response->gg;
       e && e->g.tok == zx_sp_Response_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sp_Response(c,(struct zx_sp_Response_s*)e,dup_strs);
  	  if (!enn)
  	      x->Response = (struct zx_sp_Response_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->LogoutRequest->gg;
       e && e->g.tok == zx_sp_LogoutRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sp_LogoutRequest(c,(struct zx_sp_LogoutRequest_s*)e,dup_strs);
  	  if (!enn)
  	      x->LogoutRequest = (struct zx_sp_LogoutRequest_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->LogoutResponse->gg;
       e && e->g.tok == zx_sp_LogoutResponse_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sp_LogoutResponse(c,(struct zx_sp_LogoutResponse_s*)e,dup_strs);
  	  if (!enn)
  	      x->LogoutResponse = (struct zx_sp_LogoutResponse_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->ManageNameIDRequest->gg;
       e && e->g.tok == zx_sp_ManageNameIDRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sp_ManageNameIDRequest(c,(struct zx_sp_ManageNameIDRequest_s*)e,dup_strs);
  	  if (!enn)
  	      x->ManageNameIDRequest = (struct zx_sp_ManageNameIDRequest_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->ManageNameIDResponse->gg;
       e && e->g.tok == zx_sp_ManageNameIDResponse_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sp_ManageNameIDResponse(c,(struct zx_sp_ManageNameIDResponse_s*)e,dup_strs);
  	  if (!enn)
  	      x->ManageNameIDResponse = (struct zx_sp_ManageNameIDResponse_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->Envelope->gg;
       e && e->g.tok == zx_e_Envelope_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_e_Envelope(c,(struct zx_e_Envelope_s*)e,dup_strs);
  	  if (!enn)
  	      x->Envelope = (struct zx_e_Envelope_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->Header->gg;
       e && e->g.tok == zx_e_Header_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_e_Header(c,(struct zx_e_Header_s*)e,dup_strs);
  	  if (!enn)
  	      x->Header = (struct zx_e_Header_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->Body->gg;
       e && e->g.tok == zx_e_Body_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_e_Body(c,(struct zx_e_Body_s*)e,dup_strs);
  	  if (!enn)
  	      x->Body = (struct zx_e_Body_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->EntityDescriptor->gg;
       e && e->g.tok == zx_md_EntityDescriptor_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_md_EntityDescriptor(c,(struct zx_md_EntityDescriptor_s*)e,dup_strs);
  	  if (!enn)
  	      x->EntityDescriptor = (struct zx_md_EntityDescriptor_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->EntitiesDescriptor->gg;
       e && e->g.tok == zx_md_EntitiesDescriptor_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_md_EntitiesDescriptor(c,(struct zx_md_EntitiesDescriptor_s*)e,dup_strs);
  	  if (!enn)
  	      x->EntitiesDescriptor = (struct zx_md_EntitiesDescriptor_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->XACMLAuthzDecisionQuery->gg;
       e && e->g.tok == zx_xasp_XACMLAuthzDecisionQuery_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_xasp_XACMLAuthzDecisionQuery(c,(struct zx_xasp_XACMLAuthzDecisionQuery_s*)e,dup_strs);
  	  if (!enn)
  	      x->XACMLAuthzDecisionQuery = (struct zx_xasp_XACMLAuthzDecisionQuery_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->XACMLPolicyQuery->gg;
       e && e->g.tok == zx_xasp_XACMLPolicyQuery_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_xasp_XACMLPolicyQuery(c,(struct zx_xasp_XACMLPolicyQuery_s*)e,dup_strs);
  	  if (!enn)
  	      x->XACMLPolicyQuery = (struct zx_xasp_XACMLPolicyQuery_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->xaspcd1_XACMLAuthzDecisionQuery->gg;
       e && e->g.tok == zx_xaspcd1_XACMLAuthzDecisionQuery_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_xaspcd1_XACMLAuthzDecisionQuery(c,(struct zx_xaspcd1_XACMLAuthzDecisionQuery_s*)e,dup_strs);
  	  if (!enn)
  	      x->xaspcd1_XACMLAuthzDecisionQuery = (struct zx_xaspcd1_XACMLAuthzDecisionQuery_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->xaspcd1_XACMLPolicyQuery->gg;
       e && e->g.tok == zx_xaspcd1_XACMLPolicyQuery_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_xaspcd1_XACMLPolicyQuery(c,(struct zx_xaspcd1_XACMLPolicyQuery_s*)e,dup_strs);
  	  if (!enn)
  	      x->xaspcd1_XACMLPolicyQuery = (struct zx_xaspcd1_XACMLPolicyQuery_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->EndpointReference->gg;
       e && e->g.tok == zx_a_EndpointReference_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_a_EndpointReference(c,(struct zx_a_EndpointReference_s*)e,dup_strs);
  	  if (!enn)
  	      x->EndpointReference = (struct zx_a_EndpointReference_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->Token->gg;
       e && e->g.tok == zx_sec_Token_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sec_Token(c,(struct zx_sec_Token_s*)e,dup_strs);
  	  if (!enn)
  	      x->Token = (struct zx_sec_Token_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->Candidate->gg;
       e && e->g.tok == zx_hrxml_Candidate_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_hrxml_Candidate(c,(struct zx_hrxml_Candidate_s*)e,dup_strs);
  	  if (!enn)
  	      x->Candidate = (struct zx_hrxml_Candidate_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->sa11_Assertion->gg;
       e && e->g.tok == zx_sa11_Assertion_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sa11_Assertion(c,(struct zx_sa11_Assertion_s*)e,dup_strs);
  	  if (!enn)
  	      x->sa11_Assertion = (struct zx_sa11_Assertion_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->Request->gg;
       e && e->g.tok == zx_sp11_Request_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sp11_Request(c,(struct zx_sp11_Request_s*)e,dup_strs);
  	  if (!enn)
  	      x->Request = (struct zx_sp11_Request_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->sp11_Response->gg;
       e && e->g.tok == zx_sp11_Response_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_sp11_Response(c,(struct zx_sp11_Response_s*)e,dup_strs);
  	  if (!enn)
  	      x->sp11_Response = (struct zx_sp11_Response_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->ff12_Assertion->gg;
       e && e->g.tok == zx_ff12_Assertion_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_ff12_Assertion(c,(struct zx_ff12_Assertion_s*)e,dup_strs);
  	  if (!enn)
  	      x->ff12_Assertion = (struct zx_ff12_Assertion_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->ff12_AuthnRequest->gg;
       e && e->g.tok == zx_ff12_AuthnRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_ff12_AuthnRequest(c,(struct zx_ff12_AuthnRequest_s*)e,dup_strs);
  	  if (!enn)
  	      x->ff12_AuthnRequest = (struct zx_ff12_AuthnRequest_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->AuthnResponse->gg;
       e && e->g.tok == zx_ff12_AuthnResponse_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_ff12_AuthnResponse(c,(struct zx_ff12_AuthnResponse_s*)e,dup_strs);
  	  if (!enn)
  	      x->AuthnResponse = (struct zx_ff12_AuthnResponse_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->AuthnRequestEnvelope->gg;
       e && e->g.tok == zx_ff12_AuthnRequestEnvelope_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_ff12_AuthnRequestEnvelope(c,(struct zx_ff12_AuthnRequestEnvelope_s*)e,dup_strs);
  	  if (!enn)
  	      x->AuthnRequestEnvelope = (struct zx_ff12_AuthnRequestEnvelope_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->AuthnResponseEnvelope->gg;
       e && e->g.tok == zx_ff12_AuthnResponseEnvelope_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_ff12_AuthnResponseEnvelope(c,(struct zx_ff12_AuthnResponseEnvelope_s*)e,dup_strs);
  	  if (!enn)
  	      x->AuthnResponseEnvelope = (struct zx_ff12_AuthnResponseEnvelope_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->RegisterNameIdentifierRequest->gg;
       e && e->g.tok == zx_ff12_RegisterNameIdentifierRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_ff12_RegisterNameIdentifierRequest(c,(struct zx_ff12_RegisterNameIdentifierRequest_s*)e,dup_strs);
  	  if (!enn)
  	      x->RegisterNameIdentifierRequest = (struct zx_ff12_RegisterNameIdentifierRequest_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->RegisterNameIdentifierResponse->gg;
       e && e->g.tok == zx_ff12_RegisterNameIdentifierResponse_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_ff12_RegisterNameIdentifierResponse(c,(struct zx_ff12_RegisterNameIdentifierResponse_s*)e,dup_strs);
  	  if (!enn)
  	      x->RegisterNameIdentifierResponse = (struct zx_ff12_RegisterNameIdentifierResponse_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->FederationTerminationNotification->gg;
       e && e->g.tok == zx_ff12_FederationTerminationNotification_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_ff12_FederationTerminationNotification(c,(struct zx_ff12_FederationTerminationNotification_s*)e,dup_strs);
  	  if (!enn)
  	      x->FederationTerminationNotification = (struct zx_ff12_FederationTerminationNotification_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->ff12_LogoutRequest->gg;
       e && e->g.tok == zx_ff12_LogoutRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_ff12_LogoutRequest(c,(struct zx_ff12_LogoutRequest_s*)e,dup_strs);
  	  if (!enn)
  	      x->ff12_LogoutRequest = (struct zx_ff12_LogoutRequest_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->ff12_LogoutResponse->gg;
       e && e->g.tok == zx_ff12_LogoutResponse_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_ff12_LogoutResponse(c,(struct zx_ff12_LogoutResponse_s*)e,dup_strs);
  	  if (!enn)
  	      x->ff12_LogoutResponse = (struct zx_ff12_LogoutResponse_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->NameIdentifierMappingRequest->gg;
       e && e->g.tok == zx_ff12_NameIdentifierMappingRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_ff12_NameIdentifierMappingRequest(c,(struct zx_ff12_NameIdentifierMappingRequest_s*)e,dup_strs);
  	  if (!enn)
  	      x->NameIdentifierMappingRequest = (struct zx_ff12_NameIdentifierMappingRequest_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->NameIdentifierMappingResponse->gg;
       e && e->g.tok == zx_ff12_NameIdentifierMappingResponse_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_ff12_NameIdentifierMappingResponse(c,(struct zx_ff12_NameIdentifierMappingResponse_s*)e,dup_strs);
  	  if (!enn)
  	      x->NameIdentifierMappingResponse = (struct zx_ff12_NameIdentifierMappingResponse_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->m20_EntityDescriptor->gg;
       e && e->g.tok == zx_m20_EntityDescriptor_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_m20_EntityDescriptor(c,(struct zx_m20_EntityDescriptor_s*)e,dup_strs);
  	  if (!enn)
  	      x->m20_EntityDescriptor = (struct zx_m20_EntityDescriptor_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }
  for (enn = 0, e = &x->m20_EntitiesDescriptor->gg;
       e && e->g.tok == zx_m20_EntitiesDescriptor_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
  	  en=(struct zx_elem_s*)zx_DEEP_CLONE_m20_EntitiesDescriptor(c,(struct zx_m20_EntitiesDescriptor_s*)e,dup_strs);
  	  if (!enn)
  	      x->m20_EntitiesDescriptor = (struct zx_m20_EntitiesDescriptor_s*)en;
  	  else
  	      enn->g.n = &en->g;
  	  enn = en;
  }

  return x;
}

/* FUNC(zx_WALK_SO_root) */

/* Depth first traversal of the tree in either schema order or the wire order. */
 
int zx_WALK_SO_root(struct zx_ctx* c, struct zx_root_s* x, void* ctx, int (*callback)(struct zx_node_s* node, void* ctx))
{
  struct zx_elem_s* e   MAYBE_UNUSED;
  int ret = callback(&x->gg.g, ctx);
  if (ret)
    return ret;
  
  /* *** deal with xmlns specifications in exc c14n way */


  
  ret = zx_walk_so_unknown_attributes(c, &x->gg, ctx, callback); 
  if (ret)
    return ret;

  for (e = &x->Assertion->gg;
       e && e->g.tok == zx_sa_Assertion_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sa_Assertion(c, (struct zx_sa_Assertion_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->EncryptedAssertion->gg;
       e && e->g.tok == zx_sa_EncryptedAssertion_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sa_EncryptedAssertion(c, (struct zx_sa_EncryptedAssertion_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->NameID->gg;
       e && e->g.tok == zx_sa_NameID_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sa_NameID(c, (struct zx_sa_NameID_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->EncryptedID->gg;
       e && e->g.tok == zx_sa_EncryptedID_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sa_EncryptedID(c, (struct zx_sa_EncryptedID_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  ret = zx_walk_so_simple_elems(c, x->NewID, ctx, callback);
  if (ret)
    return ret;
  for (e = &x->AuthnRequest->gg;
       e && e->g.tok == zx_sp_AuthnRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sp_AuthnRequest(c, (struct zx_sp_AuthnRequest_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->Response->gg;
       e && e->g.tok == zx_sp_Response_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sp_Response(c, (struct zx_sp_Response_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->LogoutRequest->gg;
       e && e->g.tok == zx_sp_LogoutRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sp_LogoutRequest(c, (struct zx_sp_LogoutRequest_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->LogoutResponse->gg;
       e && e->g.tok == zx_sp_LogoutResponse_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sp_LogoutResponse(c, (struct zx_sp_LogoutResponse_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->ManageNameIDRequest->gg;
       e && e->g.tok == zx_sp_ManageNameIDRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sp_ManageNameIDRequest(c, (struct zx_sp_ManageNameIDRequest_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->ManageNameIDResponse->gg;
       e && e->g.tok == zx_sp_ManageNameIDResponse_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sp_ManageNameIDResponse(c, (struct zx_sp_ManageNameIDResponse_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->Envelope->gg;
       e && e->g.tok == zx_e_Envelope_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_e_Envelope(c, (struct zx_e_Envelope_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->Header->gg;
       e && e->g.tok == zx_e_Header_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_e_Header(c, (struct zx_e_Header_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->Body->gg;
       e && e->g.tok == zx_e_Body_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_e_Body(c, (struct zx_e_Body_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->EntityDescriptor->gg;
       e && e->g.tok == zx_md_EntityDescriptor_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_md_EntityDescriptor(c, (struct zx_md_EntityDescriptor_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->EntitiesDescriptor->gg;
       e && e->g.tok == zx_md_EntitiesDescriptor_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_md_EntitiesDescriptor(c, (struct zx_md_EntitiesDescriptor_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->XACMLAuthzDecisionQuery->gg;
       e && e->g.tok == zx_xasp_XACMLAuthzDecisionQuery_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_xasp_XACMLAuthzDecisionQuery(c, (struct zx_xasp_XACMLAuthzDecisionQuery_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->XACMLPolicyQuery->gg;
       e && e->g.tok == zx_xasp_XACMLPolicyQuery_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_xasp_XACMLPolicyQuery(c, (struct zx_xasp_XACMLPolicyQuery_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->xaspcd1_XACMLAuthzDecisionQuery->gg;
       e && e->g.tok == zx_xaspcd1_XACMLAuthzDecisionQuery_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_xaspcd1_XACMLAuthzDecisionQuery(c, (struct zx_xaspcd1_XACMLAuthzDecisionQuery_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->xaspcd1_XACMLPolicyQuery->gg;
       e && e->g.tok == zx_xaspcd1_XACMLPolicyQuery_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_xaspcd1_XACMLPolicyQuery(c, (struct zx_xaspcd1_XACMLPolicyQuery_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->EndpointReference->gg;
       e && e->g.tok == zx_a_EndpointReference_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_a_EndpointReference(c, (struct zx_a_EndpointReference_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->Token->gg;
       e && e->g.tok == zx_sec_Token_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sec_Token(c, (struct zx_sec_Token_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->Candidate->gg;
       e && e->g.tok == zx_hrxml_Candidate_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_hrxml_Candidate(c, (struct zx_hrxml_Candidate_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->sa11_Assertion->gg;
       e && e->g.tok == zx_sa11_Assertion_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sa11_Assertion(c, (struct zx_sa11_Assertion_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->Request->gg;
       e && e->g.tok == zx_sp11_Request_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sp11_Request(c, (struct zx_sp11_Request_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->sp11_Response->gg;
       e && e->g.tok == zx_sp11_Response_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_sp11_Response(c, (struct zx_sp11_Response_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->ff12_Assertion->gg;
       e && e->g.tok == zx_ff12_Assertion_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_ff12_Assertion(c, (struct zx_ff12_Assertion_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->ff12_AuthnRequest->gg;
       e && e->g.tok == zx_ff12_AuthnRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_ff12_AuthnRequest(c, (struct zx_ff12_AuthnRequest_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->AuthnResponse->gg;
       e && e->g.tok == zx_ff12_AuthnResponse_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_ff12_AuthnResponse(c, (struct zx_ff12_AuthnResponse_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->AuthnRequestEnvelope->gg;
       e && e->g.tok == zx_ff12_AuthnRequestEnvelope_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_ff12_AuthnRequestEnvelope(c, (struct zx_ff12_AuthnRequestEnvelope_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->AuthnResponseEnvelope->gg;
       e && e->g.tok == zx_ff12_AuthnResponseEnvelope_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_ff12_AuthnResponseEnvelope(c, (struct zx_ff12_AuthnResponseEnvelope_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->RegisterNameIdentifierRequest->gg;
       e && e->g.tok == zx_ff12_RegisterNameIdentifierRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_ff12_RegisterNameIdentifierRequest(c, (struct zx_ff12_RegisterNameIdentifierRequest_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->RegisterNameIdentifierResponse->gg;
       e && e->g.tok == zx_ff12_RegisterNameIdentifierResponse_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_ff12_RegisterNameIdentifierResponse(c, (struct zx_ff12_RegisterNameIdentifierResponse_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->FederationTerminationNotification->gg;
       e && e->g.tok == zx_ff12_FederationTerminationNotification_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_ff12_FederationTerminationNotification(c, (struct zx_ff12_FederationTerminationNotification_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->ff12_LogoutRequest->gg;
       e && e->g.tok == zx_ff12_LogoutRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_ff12_LogoutRequest(c, (struct zx_ff12_LogoutRequest_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->ff12_LogoutResponse->gg;
       e && e->g.tok == zx_ff12_LogoutResponse_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_ff12_LogoutResponse(c, (struct zx_ff12_LogoutResponse_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->NameIdentifierMappingRequest->gg;
       e && e->g.tok == zx_ff12_NameIdentifierMappingRequest_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_ff12_NameIdentifierMappingRequest(c, (struct zx_ff12_NameIdentifierMappingRequest_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->NameIdentifierMappingResponse->gg;
       e && e->g.tok == zx_ff12_NameIdentifierMappingResponse_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_ff12_NameIdentifierMappingResponse(c, (struct zx_ff12_NameIdentifierMappingResponse_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->m20_EntityDescriptor->gg;
       e && e->g.tok == zx_m20_EntityDescriptor_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_m20_EntityDescriptor(c, (struct zx_m20_EntityDescriptor_s*)e, ctx, callback);
    if (ret)
      return ret;
  }
  for (e = &x->m20_EntitiesDescriptor->gg;
       e && e->g.tok == zx_m20_EntitiesDescriptor_ELEM;
       e = (struct zx_elem_s*)e->g.n) {
    ret = zx_WALK_SO_m20_EntitiesDescriptor(c, (struct zx_m20_EntitiesDescriptor_s*)e, ctx, callback);
    if (ret)
      return ret;
  }

  
  return zx_walk_so_unknown_elems_and_content(c, &x->gg, ctx, callback);
}

/* FUNC(zx_WALK_WO_root) */

int zx_WALK_WO_root(struct zx_ctx* c, struct zx_root_s* x, void* ctx, int (*callback)(struct zx_node_s* node, void* ctx))
{
  ERR("*** walk_wo not implemented %d", 0);
  return 0;
}

#endif




#ifdef EL_NAME
#undef EL_NAME
#endif
#ifdef EL_STRUCT
#undef EL_STRUCT
#endif
#ifdef EL_NS
#undef EL_NS
#endif
#ifdef EL_TAG
#undef EL_TAG
#endif

#define EL_NAME   simple_elem
#define EL_STRUCT zx_elem_s
#define EL_NS     
#define EL_TAG    simple_elem

/* FUNC(zx_NEW_simple_elem) */

/* Trivial allocator/constructor for the datatype. */

/* Called by: */
struct zx_elem_s* zx_NEW_simple_elem(struct zx_ctx* c, struct zx_elem_s* father)
{
  struct zx_elem_s* x = ZX_ZALLOC(c, struct zx_elem_s);
  x->g.tok = ZX_TOK_AND_NS_NOT_FOUND;
  if (father) {
    x->g.n = &father->kids->g;
    father->kids = x;
  }
  return x;
}

#ifdef ZX_ENA_AUX

/* FUNC(zx_DUP_STRS_simple_elem) */

/* Depth first traversal of data structure to copy its simple strings
 * to memory allocated from the memory allocator. The decoder will
 * use the underlying wireprotocol PDU buffer for strings, i.e.
 * strings are not copied - they point to the real data. If the
 * datastructure needs to outlast the protocol data or needs a different
 * memory allocation strategy, you need to call this function.  */

/* Called by: */
void zx_DUP_STRS_simple_elem(struct zx_ctx* c, struct zx_elem_s* x)
{
  struct zx_elem_s* se  MAYBE_UNUSED;
  zx_dup_strs_common(c, x);
  /* *** deal with xmlns specifications in exc c14n way */



}

/* FUNC(zx_DEEP_CLONE_simple_elem) */

/* Depth first traversal of data structure to clone it and its sublements.
 * The simple strings are handled as a special case according to dup_strs flag. */

/* Called by: */
struct zx_elem_s* zx_DEEP_CLONE_simple_elem(struct zx_ctx* c, struct zx_elem_s* x, int dup_strs)
{
  struct zx_elem_s* e   MAYBE_UNUSED;
  struct zx_elem_s* en  MAYBE_UNUSED;
  struct zx_elem_s* enn MAYBE_UNUSED;

  x = (struct zx_elem_s*)zx_clone_elem_common(c, x, sizeof(struct zx_elem_s), dup_strs);
  /* *** deal with xmlns specifications in exc c14n way */



  return x;
}

/* FUNC(zx_WALK_SO_simple_elem) */

/* Depth first traversal of the tree in either schema order or the wire order. */
 
int zx_WALK_SO_simple_elem(struct zx_ctx* c, struct zx_elem_s* x, void* ctx, int (*callback)(struct zx_node_s* node, void* ctx))
{
  struct zx_elem_s* e   MAYBE_UNUSED;
  int ret = callback(&x->g, ctx);
  if (ret)
    return ret;
  
  /* *** deal with xmlns specifications in exc c14n way */


  
  ret = zx_walk_so_unknown_attributes(c, x, ctx, callback); 
  if (ret)
    return ret;


  
  return zx_walk_so_unknown_elems_and_content(c, x, ctx, callback);
}

/* FUNC(zx_WALK_WO_simple_elem) */

int zx_WALK_WO_simple_elem(struct zx_ctx* c, struct zx_elem_s* x, void* ctx, int (*callback)(struct zx_node_s* node, void* ctx))
{
  ERR("*** walk_wo not implemented %d", 0);
  return 0;
}

#endif


/* EOF -- c/zx-aux.c */
